<template>
    <div class="examination">
     <el-dialog @close="closeDialog" :visible.sync="dialogTableVisible" customClass="customWidth_syst">
        <div slot="title" class="titleBox">
        <i :class="tableType === 0? 'el-icon-document':'el-icon-edit-outline'" style="font-size: 20px"></i>
        <!-- <img style="width: 25px; height: 25px" src='../../../../assets/img/imgScreen/more.png' /> -->
        <span style="margin-left:10px;font-size:18px">{{tableTypeDsc}}</span>
        </div>
       <el-form ref="baseData" label-width="80px" :rules="ruleValidate" :model="baseData">
         <el-row>
          <el-col :span="10">
            <el-form-item prop="merchName" label="客商名称">
              <el-input v-model="baseData.merchName" readonly disabled size="small"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="10">
            <el-form-item prop="matClassName" label="物料类型">
              <el-select v-model="matClassNameTypeIndex" filterable collapse-tags size="small">
                <el-option v-for="(item,index) in matClassNameType" :key="index" :label="item.matClassName" :value="index">
                </el-option>
              </el-select>
            </el-form-item>
          </el-col>
          </el-row>
          <el-row>
          <el-col :span="10">
            <el-form-item prop="evaVer" label="评价版本">
             <el-input v-model="baseData.evaVer" size="small"></el-input>
            </el-form-item>
          </el-col>
            <el-col :span="10">
            <el-form-item prop="evaLevelName" label="评价等级">
             <el-select v-model="evaLevelNameTypeIndex" filterable collapse-tags size="small">
                <el-option v-for="(item,index) in evaLevelNameType" :key="index" :label="item.baseName" :value="index">
                </el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="20">
            <el-form-item prop="evaDesc" label="评价描述">
              <el-input v-model="baseData.evaDesc" size="small"></el-input>
            </el-form-item>
          </el-col>
         </el-row>
       </el-form>
       <span slot="footer" class="dialog-footer">
        <el-button type="goon" size="mini" icon="el-icon-check" @click="tableType === 0 ? addData():modifyData()">确定</el-button>
        <el-button size="mini" type="goon" icon="el-icon-remove-outline" @click="cancel">取消</el-button>
      </span>
    </el-dialog>
    </div>
</template>
<script>
import {
  getCookie
} from '@/utils/util.js';
import {
  cookieUserId,
  cookieUserName
} from '@/config/config.js';
let userName = getCookie(cookieUserName);
let userId = getCookie(cookieUserId);
export default {
  props: ['showFlag2', 'Params', 'Params2'],
    data () {
        return {
            dialogTableVisible: false,
            tableTypeDsc: '新增客商产品评价信息',
            tableType: 0,
            seen: true,
            seenNo: true,
            beInvalid: false,
            matClassNameTypeIndex: 0,
            evaLevelNameTypeIndex: 0,
            matClassNameType: [],
            evaLevelNameType: [],
            tableData: [],
            baseData: {
              merchName: '',
              evaVer: '',
              evaDesc: ''
            },
            ruleValidate: {
              //matName: [{ required: true, message: '该项不能为空', trigger: 'change' }],
              //merchName: [{ required: true, message: '该项不能为空', trigger: 'change' }],
              // matName: [{ required: true, message: '该项不能为空', trigger: 'change' }]
             }
        }
    },
    mounted () {
      this.getMatClassNameList (),
      this.getEvaLevelName ()
    },
    methods: {
      cancel () {
        let _this = this;
        _this.tableData = [];
        _this.matClassNameTypeIndex = 0,
        _this.evaLevelNameTypeIndex = 0,
        _this.baseData = {
              merchName: '',
              evaVer: '',
              evaDesc: ''
        }
        _this.dialogTableVisible = false
        _this.$emit('refresh')
      },
      open(mag, typ, time) {
        this.$message({
          showClose: true,
          message: mag,
          type: typ,
          duration: time
        });
      },
      addData () {
        let _this = this;
         _this.tableData = [];
         _this.$refs['baseData'].validate((valid) => {
          if (valid) {
             _this.dialogTableVisible = false;
             _this.baseData.apprManName = userName;
             _this.baseData.apprManNo = userId;
             _this.baseData.matClassNo = _this.matClassNameType[_this.matClassNameTypeIndex].matClassNo;
             _this.baseData.matClassName = _this.matClassNameType[_this.matClassNameTypeIndex].matClassName;
             _this.baseData.evaLevelCode = _this.evaLevelNameType[_this.evaLevelNameTypeIndex].baseCode;
             _this.baseData.evaLevelName = _this.evaLevelNameType[_this.evaLevelNameTypeIndex].baseName;
             _this.tableData.push(_this.baseData)
             _this.axios.post('pass/baseManagement/v1/limsmerchantsevas/', _this.tableData, {individualType: 'json'}).then(res => {
                if (res.succeed) {
                 this.open('添加成功', 'success', 1200)
                 _this.$emit('refresh')
                } else {
                 this.$message.error(res.message)
                }
                }).catch(e => {
                 this.$message.error(e.message)
               })
         }
       })
      },
      modifyData () {
        let _this = this;
         _this.tableData = [];
        _this.$refs['baseData'].validate((valid) => {
        if (valid) {
        _this.dialogTableVisible = false;
        _this.baseData.apprManName = userName;
        _this.baseData.apprManNo = userId;
        _this.baseData.matClassNo = _this.matClassNameType[_this.matClassNameTypeIndex].matClassNo;
        _this.baseData.matClassName = _this.matClassNameType[_this.matClassNameTypeIndex].matClassName;
        _this.baseData.evaLevelCode = _this.evaLevelNameType[_this.evaLevelNameTypeIndex].baseCode;
        _this.baseData.evaLevelName = _this.evaLevelNameType[_this.evaLevelNameTypeIndex].baseName;
        _this.tableData.push(_this.baseData)
        _this.axios.put('pass/baseManagement/v1/limsmerchantsevas/', _this.baseData, {individualType: 'json'}).then(res => {
           if (res.succeed) {
             this.open('修改成功', 'success', 1200)
            _this.$emit('refresh')
           } else {
            this.$message.error(res.message)
           }
           }).catch(e => {
            this.$message.error(e.message)
          })
        }
        })
      },
      renderHeader (h) {
         return (
             <div style="cursor: pointer ;line-height:20px" onClick={() => this.addRow()}>
             <i class="el-icon-plus" style="font-size:20px; color:rgb(18, 52, 243)"></i>
             </div>
         )
      },
     closeDialog () {
       let _this = this;
       _this.tableData = [];
       _this.baseData = {
              merchName: '',
              evaVer: '',
              evaDesc: ''
        }
       _this.seen = true;
       _this.seenNo = true;
       _this.beInvalid = false;
       _this.$emit('refresh')
     },
     getMatClassNameList () {
         this.axios.get('pass/baseManagement/v1/limsbasematerialsclasss/'+ '?validFlag=1')
            .then(res => {
              this.matClassNameType = res.data.list
            })
      },
      getEvaLevelName () {
        this.axios.post("pass/baseManagement/v1/limsbaseinfos/queryBaseInfoByBaseCode",{validFlag:1,baseCode:4837}, {individualType: 'json'}).then(res => {
              this.evaLevelNameType = res.data;
            }).catch(e => {
              // this.dataLoading = false;
            });
      },
      tableHeaderCellStyle () {
      return 'background-color: rgb(249,249,249) !important;color: rgb(73, 72, 72);border-bottom: 1px solid #DCDFE7;border-top:3px solid #3ac1ea;'
      }
    },
    watch: {
      showFlag2 (arg) {
        let _this = this;
        _this.dialogTableVisible = true;
        if (_this.Params2 !== null) {
          _this.baseData = _this.Params2;
          _this.tableType = 1;
          _this.tableTypeDsc = '修改客商产品评价信息';
          _this.seen = false;
          _this.beInvalid = true;
          for (let j = 0; j < _this.matClassNameType.length; j++) {
          if (_this.matClassNameType[j].matClassName === _this.baseData.matClassName) {
             _this.matClassNameTypeIndex = j;
          }
          }
          for (let j = 0; j < _this.evaLevelNameType.length; j++) {
          if (_this.evaLevelNameType[j].baseName === _this.baseData.evaLevelName) {
             _this.evaLevelNameTypeIndex = j;
          }
          }
        } else {
          _this.tableType = 0;
          _this.seenNo = false;
          _this.baseData.merchName = _this.Params.merchName;
          _this.baseData.merchNo = _this.Params.merchNo;
          _this.baseData.mmId = _this.Params.mmId;
          _this.tableTypeDsc = '新增客商产品评价信息';
        }
      }
    }
}
</script>
<style lang="less">
.customWidth_syst{
  width: 600px !important
}
</style>
